
/*
 *  Copyright (C) 2010-2011 Oracle Corporation
 *
 *  This file is part of the VirtualBox SDK, as available from
 *  http://www.virtualbox.org.  This library is free software; you can
 *  redistribute it and/or modify it under the terms of the GNU Lesser General
 *  Public License as published by the Free Software Foundation, in version 2.1
 *  as it comes in the "COPYING.LIB" file of the VirtualBox SDK distribution.
 *  This library is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 *  License for more details.
 *
 * IFile.java
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl (VirtualBox's interface definitions in XML)
 * Generator: src/VBox/Main/glue/glue-java.xsl
 */

package org.virtualbox_4_2;

import org.virtualbox_4_2.jaxws.*;
import javax.xml.ws.*;
import java.util.List;

/**

      TODO
    
Interface ID: <tt>{2615152D-35C0-4363-8325-AB7E1F2B8B34}</tt>
*/
public class IFile extends IUnknown {

    public IFile(String wrapped, VboxPortType port) {
          super(wrapped, port);
    }
/**

        TODO
        
NOTE: 
          TODO
        

@return String

*/
    public String getFileName() {
      try {
         String retVal = port.iFileGetFileName(obj);
         return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
        
NOTE: 
          TODO
        

@return Long

*/
    public Long getInitialSize() {
      try {
         Long retVal = port.iFileGetInitialSize(obj);
         return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
        
NOTE: 
          TODO
        

@return Long

*/
    public Long getOpenMode() {
      try {
         Long retVal = port.iFileGetOpenMode(obj);
         return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
        
NOTE: 
          TODO
        

@return Long

*/
    public Long getOffset() {
      try {
         Long retVal = port.iFileGetOffset(obj);
         return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
    public static IFile queryInterface(IUnknown obj) {
       return obj == null ?  null : new IFile(obj.getWrapped(), obj.getRemoteWSPort());
    }
/**

        TODO

        
Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public void close() {
      try {
        port.iFileClose(obj);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public org.virtualbox_4_2.IFsObjInfo queryInfo() {
      try {
        String     retVal;
        retVal = port.iFileQueryInfo(obj);
        return (retVal.length() > 0) ? new org.virtualbox_4_2.IFsObjInfo(retVal, port) : null;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param toRead TODO

@param read TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public byte[] read(Long toRead, Holder<Long> read) {
      try {
        javax.xml.ws.Holder<Long>   tmp_read = new  javax.xml.ws.Holder<Long>();
        javax.xml.ws.Holder</*base64*/String> retVal = new javax.xml.ws.Holder</*base64*/String>();
        port.iFileRead(obj, toRead, tmp_read, retVal);
        read.value = tmp_read.value;
        return Helper.decodeBase64(retVal.value);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param offset TODO

@param toRead TODO

@param read TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public byte[] readAt(Long offset, Long toRead, Holder<Long> read) {
      try {
        javax.xml.ws.Holder<Long>   tmp_read = new  javax.xml.ws.Holder<Long>();
        javax.xml.ws.Holder</*base64*/String> retVal = new javax.xml.ws.Holder</*base64*/String>();
        port.iFileReadAt(obj, offset, toRead, tmp_read, retVal);
        read.value = tmp_read.value;
        return Helper.decodeBase64(retVal.value);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param offset TODO

@param whence TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public void seek(Long offset, org.virtualbox_4_2.FileSeekType whence) {
      try {
        port.iFileSeek(obj, offset, org.virtualbox_4_2.jaxws.FileSeekType.fromValue(whence.name()));
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param acl TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public void setACL(String acl) {
      try {
        port.iFileSetACL(obj, acl);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param data TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public Long write(byte[] data) {
      try {
        Long     retVal;
        retVal = port.iFileWrite(obj, Helper.encodeBase64(data));
        return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param offset TODO

@param data TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public Long writeAt(Long offset, byte[] data) {
      try {
        Long     retVal;
        retVal = port.iFileWriteAt(obj, offset, Helper.encodeBase64(data));
        return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
}
