
/*
 *  Copyright (C) 2010-2011 Oracle Corporation
 *
 *  This file is part of the VirtualBox SDK, as available from
 *  http://www.virtualbox.org.  This library is free software; you can
 *  redistribute it and/or modify it under the terms of the GNU Lesser General
 *  Public License as published by the Free Software Foundation, in version 2.1
 *  as it comes in the "COPYING.LIB" file of the VirtualBox SDK distribution.
 *  This library is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 *  License for more details.
 *
 * IGuestSession.java
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl (VirtualBox's interface definitions in XML)
 * Generator: src/VBox/Main/glue/glue-java.xsl
 */

package org.virtualbox_4_2;

import org.virtualbox_4_2.jaxws.*;
import javax.xml.ws.*;
import java.util.List;

public class IGuestSession extends IUnknown {

    public IGuestSession(String wrapped, VboxPortType port) {
          super(wrapped, port);
    }
/**

        TODO
        
NOTE: 
          TODO
        

@return String

*/
    public String getUser() {
      try {
         String retVal = port.iGuestSessionGetUser(obj);
         return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
        
NOTE: 
          TODO
        

@return String

*/
    public String getDomain() {
      try {
         String retVal = port.iGuestSessionGetDomain(obj);
         return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
        
NOTE: 
          TODO
        

@return String

*/
    public String getName() {
      try {
         String retVal = port.iGuestSessionGetName(obj);
         return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
        
NOTE: 
          TODO
        

@return Long

*/
    public Long getId() {
      try {
         Long retVal = port.iGuestSessionGetId(obj);
         return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
        
NOTE: 
          TODO
        

@return Long

*/
    public Long getTimeout() {
      try {
         Long retVal = port.iGuestSessionGetTimeout(obj);
         return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
        
NOTE: 
          TODO
        

@param value Long

*/
    public void setTimeout(Long value) {
      try {
        port.iGuestSessionSetTimeout(obj, value);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
      
@return List<String>

*/
    public List<String> getEnvironment() {
      try {
         List<String> retVal = port.iGuestSessionGetEnvironment(obj);
         return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
      
@param value List<String>

*/
    public void setEnvironment(List<String> value) {
      try {
        port.iGuestSessionSetEnvironment(obj, value);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
      
@return List<org.virtualbox_4_2.IGuestProcess>

*/
    public List<org.virtualbox_4_2.IGuestProcess> getProcesses() {
      try {
         List<String> retVal = port.iGuestSessionGetProcesses(obj);
         return Helper.wrap(org.virtualbox_4_2.IGuestProcess.class, port, retVal);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
      
@return List<org.virtualbox_4_2.IGuestDirectory>

*/
    public List<org.virtualbox_4_2.IGuestDirectory> getDirectories() {
      try {
         List<String> retVal = port.iGuestSessionGetDirectories(obj);
         return Helper.wrap(org.virtualbox_4_2.IGuestDirectory.class, port, retVal);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
      
@return List<org.virtualbox_4_2.IGuestFile>

*/
    public List<org.virtualbox_4_2.IGuestFile> getFiles() {
      try {
         List<String> retVal = port.iGuestSessionGetFiles(obj);
         return Helper.wrap(org.virtualbox_4_2.IGuestFile.class, port, retVal);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
    public static IGuestSession queryInterface(IUnknown obj) {
       return obj == null ?  null : new IGuestSession(obj.getWrapped(), obj.getRemoteWSPort());
    }
/**

        TODO

        
Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public void close() {
      try {
        port.iGuestSessionClose(obj);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param source TODO

@param dest TODO

@param flags TODO

@return Progress object to track the operation completion.

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public org.virtualbox_4_2.IProgress copyFrom(String source, String dest, List<org.virtualbox_4_2.CopyFileFlag> flags) {
      try {
        String     retVal;
        retVal = port.iGuestSessionCopyFrom(obj, source, dest, Helper.convertEnums(org.virtualbox_4_2.CopyFileFlag.class,org.virtualbox_4_2.jaxws.CopyFileFlag.class,flags));
        return (retVal.length() > 0) ? new org.virtualbox_4_2.IProgress(retVal, port) : null;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param source TODO

@param dest TODO

@param flags TODO

@return Progress object to track the operation completion.

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public org.virtualbox_4_2.IProgress copyTo(String source, String dest, List<org.virtualbox_4_2.CopyFileFlag> flags) {
      try {
        String     retVal;
        retVal = port.iGuestSessionCopyTo(obj, source, dest, Helper.convertEnums(org.virtualbox_4_2.CopyFileFlag.class,org.virtualbox_4_2.jaxws.CopyFileFlag.class,flags));
        return (retVal.length() > 0) ? new org.virtualbox_4_2.IProgress(retVal, port) : null;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param path TODO

@param mode TODO

@param flags TODO

@return Optional.

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public org.virtualbox_4_2.IGuestDirectory directoryCreate(String path, Long mode, List<org.virtualbox_4_2.DirectoryCreateFlag> flags) {
      try {
        String     retVal;
        retVal = port.iGuestSessionDirectoryCreate(obj, path, mode, Helper.convertEnums(org.virtualbox_4_2.DirectoryCreateFlag.class,org.virtualbox_4_2.jaxws.DirectoryCreateFlag.class,flags));
        return (retVal.length() > 0) ? new org.virtualbox_4_2.IGuestDirectory(retVal, port) : null;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param templateName TODO

@param mode TODO

@param path TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public org.virtualbox_4_2.IGuestDirectory directoryCreateTemp(String templateName, Long mode, String path) {
      try {
        String     retVal;
        retVal = port.iGuestSessionDirectoryCreateTemp(obj, templateName, mode, path);
        return (retVal.length() > 0) ? new org.virtualbox_4_2.IGuestDirectory(retVal, port) : null;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param path TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public Boolean directoryExists(String path) {
      try {
        Boolean     retVal;
        retVal = port.iGuestSessionDirectoryExists(obj, path);
        return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param path TODO

@param filter TODO

@param flags TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public org.virtualbox_4_2.IGuestDirectory directoryOpen(String path, String filter, String flags) {
      try {
        String     retVal;
        retVal = port.iGuestSessionDirectoryOpen(obj, path, filter, flags);
        return (retVal.length() > 0) ? new org.virtualbox_4_2.IGuestDirectory(retVal, port) : null;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param path TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public org.virtualbox_4_2.IGuestFsObjInfo directoryQueryInfo(String path) {
      try {
        String     retVal;
        retVal = port.iGuestSessionDirectoryQueryInfo(obj, path);
        return (retVal.length() > 0) ? new org.virtualbox_4_2.IGuestFsObjInfo(retVal, port) : null;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param path TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public void directoryRemove(String path) {
      try {
        port.iGuestSessionDirectoryRemove(obj, path);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param path TODO

@param flags TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public org.virtualbox_4_2.IProgress directoryRemoveRecursive(String path, List<org.virtualbox_4_2.DirectoryRemoveRecFlag> flags) {
      try {
        String     retVal;
        retVal = port.iGuestSessionDirectoryRemoveRecursive(obj, path, Helper.convertEnums(org.virtualbox_4_2.DirectoryRemoveRecFlag.class,org.virtualbox_4_2.jaxws.DirectoryRemoveRecFlag.class,flags));
        return (retVal.length() > 0) ? new org.virtualbox_4_2.IProgress(retVal, port) : null;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param source TODO

@param dest TODO

@param flags TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public void directoryRename(String source, String dest, List<org.virtualbox_4_2.PathRenameFlag> flags) {
      try {
        port.iGuestSessionDirectoryRename(obj, source, dest, Helper.convertEnums(org.virtualbox_4_2.PathRenameFlag.class,org.virtualbox_4_2.jaxws.PathRenameFlag.class,flags));
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param path TODO

@param acl TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public void directorySetACL(String path, String acl) {
      try {
        port.iGuestSessionDirectorySetACL(obj, path, acl);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public void environmentClear() {
      try {
        port.iGuestSessionEnvironmentClear(obj);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param name TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public String environmentGet(String name) {
      try {
        String     retVal;
        retVal = port.iGuestSessionEnvironmentGet(obj, name);
        return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param name TODO

@param value TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public void environmentSet(String name, String value) {
      try {
        port.iGuestSessionEnvironmentSet(obj, name, value);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param name TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public void environmentUnset(String name) {
      try {
        port.iGuestSessionEnvironmentUnset(obj, name);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param templateName TODO

@param mode TODO

@param path TODO

@return Optional.

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public org.virtualbox_4_2.IGuestFile fileCreateTemp(String templateName, Long mode, String path) {
      try {
        String     retVal;
        retVal = port.iGuestSessionFileCreateTemp(obj, templateName, mode, path);
        return (retVal.length() > 0) ? new org.virtualbox_4_2.IGuestFile(retVal, port) : null;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param path TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public Boolean fileExists(String path) {
      try {
        Boolean     retVal;
        retVal = port.iGuestSessionFileExists(obj, path);
        return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param path TODO

@param openMode TODO

@param disposition TODO

@param creationMode TODO

@param offset TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public org.virtualbox_4_2.IGuestFile fileOpen(String path, String openMode, String disposition, Long creationMode, Long offset) {
      try {
        String     retVal;
        retVal = port.iGuestSessionFileOpen(obj, path, openMode, disposition, creationMode, offset);
        return (retVal.length() > 0) ? new org.virtualbox_4_2.IGuestFile(retVal, port) : null;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param path TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public org.virtualbox_4_2.IGuestFsObjInfo fileQueryInfo(String path) {
      try {
        String     retVal;
        retVal = port.iGuestSessionFileQueryInfo(obj, path);
        return (retVal.length() > 0) ? new org.virtualbox_4_2.IGuestFsObjInfo(retVal, port) : null;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param path TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public Long fileQuerySize(String path) {
      try {
        Long     retVal;
        retVal = port.iGuestSessionFileQuerySize(obj, path);
        return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param source TODO

@param dest TODO

@param flags TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public void fileRename(String source, String dest, List<org.virtualbox_4_2.PathRenameFlag> flags) {
      try {
        port.iGuestSessionFileRename(obj, source, dest, Helper.convertEnums(org.virtualbox_4_2.PathRenameFlag.class,org.virtualbox_4_2.jaxws.PathRenameFlag.class,flags));
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param file TODO

@param acl TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public void fileSetACL(String file, String acl) {
      try {
        port.iGuestSessionFileSetACL(obj, file, acl);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param command TODO

@param arguments TODO

@param environment TODO

@param flags TODO

@param timeoutMS TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public org.virtualbox_4_2.IGuestProcess processCreate(String command, List<String> arguments, List<String> environment, List<org.virtualbox_4_2.ProcessCreateFlag> flags, Long timeoutMS) {
      try {
        String     retVal;
        retVal = port.iGuestSessionProcessCreate(obj, command, arguments, environment, Helper.convertEnums(org.virtualbox_4_2.ProcessCreateFlag.class,org.virtualbox_4_2.jaxws.ProcessCreateFlag.class,flags), timeoutMS);
        return (retVal.length() > 0) ? new org.virtualbox_4_2.IGuestProcess(retVal, port) : null;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param command TODO

@param arguments TODO

@param environment TODO

@param flags TODO

@param timeoutMS TODO

@param priority TODO

@param affinity TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public org.virtualbox_4_2.IGuestProcess processCreateEx(String command, List<String> arguments, List<String> environment, List<org.virtualbox_4_2.ProcessCreateFlag> flags, Long timeoutMS, org.virtualbox_4_2.ProcessPriority priority, List<Integer> affinity) {
      try {
        String     retVal;
        retVal = port.iGuestSessionProcessCreateEx(obj, command, arguments, environment, Helper.convertEnums(org.virtualbox_4_2.ProcessCreateFlag.class,org.virtualbox_4_2.jaxws.ProcessCreateFlag.class,flags), timeoutMS, org.virtualbox_4_2.jaxws.ProcessPriority.fromValue(priority.name()), affinity);
        return (retVal.length() > 0) ? new org.virtualbox_4_2.IGuestProcess(retVal, port) : null;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param pid TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public org.virtualbox_4_2.IGuestProcess processGet(Long pid) {
      try {
        String     retVal;
        retVal = port.iGuestSessionProcessGet(obj, pid);
        return (retVal.length() > 0) ? new org.virtualbox_4_2.IGuestProcess(retVal, port) : null;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param source TODO

@param target TODO

@param type TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public void symlinkCreate(String source, String target, org.virtualbox_4_2.SymlinkType type) {
      try {
        port.iGuestSessionSymlinkCreate(obj, source, target, org.virtualbox_4_2.jaxws.SymlinkType.fromValue(type.name()));
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param symlink TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public Boolean symlinkExists(String symlink) {
      try {
        Boolean     retVal;
        retVal = port.iGuestSessionSymlinkExists(obj, symlink);
        return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param symlink TODO

@param flags TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public String symlinkRead(String symlink, List<org.virtualbox_4_2.SymlinkReadFlag> flags) {
      try {
        String     retVal;
        retVal = port.iGuestSessionSymlinkRead(obj, symlink, Helper.convertEnums(org.virtualbox_4_2.SymlinkReadFlag.class,org.virtualbox_4_2.jaxws.SymlinkReadFlag.class,flags));
        return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param path TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public void symlinkRemoveDirectory(String path) {
      try {
        port.iGuestSessionSymlinkRemoveDirectory(obj, path);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param file TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public void symlinkRemoveFile(String file) {
      try {
        port.iGuestSessionSymlinkRemoveFile(obj, file);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
}
