
/*
 *  Copyright (C) 2010-2011 Oracle Corporation
 *
 *  This file is part of the VirtualBox SDK, as available from
 *  http://www.virtualbox.org.  This library is free software; you can
 *  redistribute it and/or modify it under the terms of the GNU Lesser General
 *  Public License as published by the Free Software Foundation, in version 2.1
 *  as it comes in the "COPYING.LIB" file of the VirtualBox SDK distribution.
 *  This library is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 *  License for more details.
 *
 * IProcess.java
 *
 * DO NOT EDIT! This is a generated file.
 * Generated from: src/VBox/Main/idl/VirtualBox.xidl (VirtualBox's interface definitions in XML)
 * Generator: src/VBox/Main/glue/glue-java.xsl
 */

package org.virtualbox_4_2;

import org.virtualbox_4_2.jaxws.*;
import javax.xml.ws.*;
import java.util.List;

/**

      TODO
    
Interface ID: <tt>{896DF50A-C5D1-4892-8BC6-B78D0C1F4E33}</tt>
*/
public class IProcess extends IUnknown {

    public IProcess(String wrapped, VboxPortType port) {
          super(wrapped, port);
    }
/**

        TODO
        
NOTE: 
          TODO
        

@return Long

*/
    public Long getPID() {
      try {
         Long retVal = port.iProcessGetPID(obj);
         return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
        
NOTE: 
          TODO
        

@return org.virtualbox_4_2.ProcessStatus

*/
    public org.virtualbox_4_2.ProcessStatus getStatus() {
      try {
         org.virtualbox_4_2.jaxws.ProcessStatus retVal = port.iProcessGetStatus(obj);
         return org.virtualbox_4_2.ProcessStatus.fromValue(retVal.value());
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
        
NOTE: 
          TODO
        

@return Integer

*/
    public Integer getExitCode() {
      try {
         Integer retVal = port.iProcessGetExitCode(obj);
         return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
        
NOTE: 
          TODO
        

@return List<String>

*/
    public List<String> getEnvironment() {
      try {
         List<String> retVal = port.iProcessGetEnvironment(obj);
         return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
        
NOTE: 
          TODO
        

@return List<String>

*/
    public List<String> getArguments() {
      try {
         List<String> retVal = port.iProcessGetArguments(obj);
         return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
        
NOTE: 
          TODO
        

@return String

*/
    public String getExecutablePath() {
      try {
         String retVal = port.iProcessGetExecutablePath(obj);
         return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO
        
NOTE: 
          TODO
        

@return String

*/
    public String getName() {
      try {
         String retVal = port.iProcessGetName(obj);
         return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
    public static IProcess queryInterface(IUnknown obj) {
       return obj == null ?  null : new IProcess(obj.getWrapped(), obj.getRemoteWSPort());
    }
/**

        TODO

        
@param waitFor TODO

@param timeoutMS TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public org.virtualbox_4_2.ProcessWaitResult waitFor(Long waitFor, Long timeoutMS) {
      try {
        org.virtualbox_4_2.jaxws.ProcessWaitResult     retVal;
        retVal = port.iProcessWaitFor(obj, waitFor, timeoutMS);
        return org.virtualbox_4_2.ProcessWaitResult.fromValue(retVal.value());
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        Scriptable version of {@link #waitFor(Long,Long)}.

        
@param waitFor TODO

@param timeoutMS TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public org.virtualbox_4_2.ProcessWaitResult waitForArray(List<org.virtualbox_4_2.ProcessWaitForFlag> waitFor, Long timeoutMS) {
      try {
        org.virtualbox_4_2.jaxws.ProcessWaitResult     retVal;
        retVal = port.iProcessWaitForArray(obj, Helper.convertEnums(org.virtualbox_4_2.ProcessWaitForFlag.class,org.virtualbox_4_2.jaxws.ProcessWaitForFlag.class,waitFor), timeoutMS);
        return org.virtualbox_4_2.ProcessWaitResult.fromValue(retVal.value());
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param handle TODO

@param size TODO

@param timeoutMS TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public byte[] read(Long handle, Long size, Long timeoutMS) {
      try {
        /*base64*/String     retVal;
        retVal = port.iProcessRead(obj, handle, size, timeoutMS);
        return Helper.decodeBase64(retVal);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param handle TODO

@param flags {@link org.virtualbox_4_2.ProcessInputFlag} flags.
        

@param data TODO

@param timeoutMS TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public Long write(Long handle, Long flags, byte[] data, Long timeoutMS) {
      try {
        Long     retVal;
        retVal = port.iProcessWrite(obj, handle, flags, Helper.encodeBase64(data), timeoutMS);
        return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
@param handle TODO

@param flags {@link org.virtualbox_4_2.ProcessInputFlag} flags.
        

@param data TODO

@param timeoutMS TODO

@return TODO

Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public Long WriteArray(Long handle, List<org.virtualbox_4_2.ProcessInputFlag> flags, byte[] data, Long timeoutMS) {
      try {
        Long     retVal;
        retVal = port.iProcessWriteArray(obj, handle, Helper.convertEnums(org.virtualbox_4_2.ProcessInputFlag.class,org.virtualbox_4_2.jaxws.ProcessInputFlag.class,flags), Helper.encodeBase64(data), timeoutMS);
        return retVal;
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
/**

        TODO

        
Expected result codes:
<table>
<tr><td>@link ::VBOX_E_NOT_SUPPORTED VBOX_E_NOT_SUPPORTED</td><td>
          TODO
        </td><tr>
</table>

*/
    public void terminate() {
      try {
        port.iProcessTerminate(obj);
     } catch (InvalidObjectFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     } catch (RuntimeFaultMsg e) {
          throw new VBoxException(e, e.getMessage());
     }
    }
}
